
;PlayStatic.cpp translated for masm by ToutEnMasm
;/*
; * Copyright (c) 2006, Creative Labs Inc.
; * All rights reserved.
; * 
; * Redistribution and use in source and binary forms, with or without modification, are permitted provided
; * that the following conditions are met:
; * 
; *     * Redistributions of source code must retain the above copyright notice, this list of conditions and
; * 	     the following disclaimer.
; *     * Redistributions in binary form must reproduce the above copyright notice, this list of conditions
; * 	     and the following disclaimer in the documentation and/or other materials provided with the distribution.
; *     * Neither the name of Creative Labs Inc. nor the names of its contributors may be used to endorse or
; * 	     promote products derived from this software without specific prior written permission.
; * 
; * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
; * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
; * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
; * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
; * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
; * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
; * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
; * POSSIBILITY OF SUCH DAMAGE.
; */


.NOLIST			;signifie: ne rien mettre dans le listing
;------ emplacement des dclarations
	.486
	.model flat, stdcall
	option casemap :none   ; case sensitive

	include translate.inc	;SDK translate include files (voir mon site)
	include windows.sdk
	TARGET_OS_MAC equ 0
	include al.sdk
	include alc.sdk
	include efx.sdk
	include efx-creative.sdk
	include xram.sdk
	include framework.sdk
	;------- librairie courantes ,identiques masm32rt	
      includelib kernel32.lib
      includelib OpenAL32.lib
	includelib  libcmtd.lib ;msvcrt.lib
	
	;editmasm.ini pour l'environnement du projet
	;Failed to load ..\..\Media\Footsteps.wav
	include macro.inc
	.const
	extern c _FPinit:dword	; to load floating point library
	;avoid the R6002 floating point not loaded error 
	
	AlSourceCode PROTO
	
	.data
	hInstance dd 0
	presource dd 0
	cause db "PlayStatic Test Application translated by ToutEnMasm",13,10,0
	alfailed db "Failed to initialize OpenAL",13,10,0
	mediafailed db "Failed to load "
	;mediasource db "D:\Program Files\OpenAL 1.1 SDK\samples\media\Footsteps.wav",0
	mediasource db "Footsteps.wav",0	
	.code

	
;################################################################
PlayStatic PROC 
	Local  uiBuffer:DWORD,uiSource,iState
	Local  retour:DWORD
	ZEROLOCALES retour
	; Initialize Framework
	invoke ALFWInit	
	invoke ALFWprintf,addr cause ;"PlayStatic Test Application translated by ToutEnMasm"
	invoke ALFWInitOpenAL
	.if eax == 0
		invoke ALFWprintf,addr alfailed
		invoke ALFWShutdown
		mov retour,0
		jmp FindePlayStatic
	.endif
	;Generate an AL Buffer
	invoke alGenBuffers,1,addr uiBuffer
	;Load Wave file into OpenAL Buffer
	;invoke ALFWaddMediaPath,TEST_WAVE_FILE
	invoke ALFWLoadWaveToBuffer,addr mediasource, uiBuffer,NULL	
	.if eax == 0
		invoke ALFWprintf,addr mediafailed
	.endif	
	; Generate a Source to playback the Buffer
    	invoke alGenSources,1, addr uiSource 
	;Attach Source to Buffer
	invoke alSourcei,uiSource, AL_BUFFER, uiBuffer
	; Play Source
    	invoke alSourcePlay,uiSource
	invoke ALFWprintf,SADR("Playing Source ")
	mov 	iState,AL_PLAYING
	.WHILE (iState == AL_PLAYING)	 		
		invoke Sleep,100
		invoke ALFWprintf,SADR(".")
		; Get Source State
		invoke alGetSourcei,uiSource, AL_SOURCE_STATE,addr iState
	.ENDW
	; Clean up by deleting Source(s) and Buffer(s)
	invoke alSourceStop,uiSource
    	invoke alDeleteSources,1,addr uiSource
	invoke alDeleteBuffers,1,addr uiBuffer
	invoke ALFWShutdownOpenAL
      mov retour,0
	invoke ALFWShutdown
 FindePlayStatic:
         mov eax,retour
         ret
PlayStatic endp

;################################################################

main PROC C argc:DWORD,pargv:DWORD
	;pas de ExitProcess	;la fin est dans la librairie c ainsi que le dbut
	invoke PlayStatic			
	ret
main endp

end  
	
